package com.minemaarten.signals.block;

import net.minecraft.block.Block;
import net.minecraft.block.properties.PropertyBool;
import net.minecraft.block.state.BlockStateContainer;
import net.minecraft.block.state.IBlockState;
import net.minecraft.entity.player.EntityPlayer;
import net.minecraft.init.Items;
import net.minecraft.item.ItemStack;
import net.minecraft.util.EnumFacing;
import net.minecraft.util.EnumHand;
import net.minecraft.util.math.AxisAlignedBB;
import net.minecraft.util.math.BlockPos;
import net.minecraft.world.IBlockAccess;
import net.minecraft.world.World;

import com.minemaarten.signals.proxy.CommonProxy.EnumGuiId;
import com.minemaarten.signals.rail.network.mc.RailNetworkManager;
import com.minemaarten.signals.tileentity.TileEntityStationMarker;

public class BlockStationMarker extends BlockBase{

    public static PropertyBool VALID = PropertyBool.func_177716_a("valid");

    public BlockStationMarker(){
        super(TileEntityStationMarker.class, "station_marker");
    }

    @Override
    public AxisAlignedBB func_185496_a(IBlockState state, IBlockAccess source, BlockPos pos){
        return new AxisAlignedBB(4 / 16F, 0.0F, 4 / 16F, 12 / 16F, 16 / 16F, 12 / 16F);
    }

    @Override
    protected BlockStateContainer func_180661_e(){
        return new BlockStateContainer(this, VALID);
    }

    @Override
    public int func_176201_c(IBlockState state){
        return state.func_177229_b(VALID) ? 1 : 0;
    }

    @Override
    public IBlockState func_176203_a(int meta){
        return super.func_176203_a(meta).func_177226_a(VALID, meta == 1);
    }

    @Override
    public EnumGuiId getGuiID(){
        return EnumGuiId.STATION_MARKER;
    }

    @Override
    public boolean func_149662_c(IBlockState state){
        return false;
    }

    @Override
    public boolean func_149686_d(IBlockState state){
        return false;
    }

    @Override
    public void func_176213_c(World worldIn, BlockPos pos, IBlockState state){
        super.func_176213_c(worldIn, pos, state);
        updateStationState(worldIn, pos, state);
    }

    @Override
    public void func_189540_a(IBlockState state, World worldIn, BlockPos pos, Block blockIn, BlockPos fromPos){
        super.func_189540_a(state, worldIn, pos, blockIn, fromPos);
        updateStationState(worldIn, pos, state);
    }

    public void updateStationState(World world, BlockPos pos, IBlockState state){
        boolean neighborRail = false;
        for(EnumFacing d : EnumFacing.field_82609_l) {
            if(RailNetworkManager.getInstance(world.field_72995_K).getRail(world, pos.func_177972_a(d)) != null) {
                neighborRail = true;
                break;
            }
        }
        world.func_180501_a(pos, state.func_177226_a(VALID, neighborRail), 2);
    }

    @Override
    public boolean func_180639_a(World world, BlockPos pos, IBlockState state, EntityPlayer player, EnumHand hand, EnumFacing face, float par7, float par8, float par9){
        if(player.func_70093_af()) return false;
        else {
            ItemStack stack = player.func_184586_b(hand);
            if(!world.field_72995_K && stack.func_77973_b() == Items.field_151057_cb && stack.func_82837_s()) {
                TileEntityStationMarker stationMarker = (TileEntityStationMarker)world.func_175625_s(pos);
                stationMarker.setStationName(stack.func_82833_r());
                return true;
            } else {
                return super.func_180639_a(world, pos, state, player, hand, face, par7, par8, par9);
            }
        }
    }
}
