package com.minemaarten.signals.tileentity;

import net.minecraft.entity.player.EntityPlayer;
import net.minecraft.nbt.NBTTagCompound;

import com.minemaarten.signals.block.BlockRailLink;
import com.minemaarten.signals.network.GuiSynced;
import com.minemaarten.signals.rail.network.NetworkRail;
import com.minemaarten.signals.rail.network.mc.MCPos;
import com.minemaarten.signals.rail.network.mc.RailNetworkManager;

public class TileEntityRailLink extends TileEntityRailLinkBase implements IGUIButtonSensitive{
    @GuiSynced
    private int holdDelay;

    @Override
    public void handleGUIButtonPress(EntityPlayer player, int... data){
        if(data[0] != holdDelay) {
            holdDelay = data[0];
            RailNetworkManager.getInstance(field_145850_b.field_72995_K).markDirty(getMCPos());
        }
    }

    public int getHoldDelay(){
        return holdDelay;
    }

    @Override
    public NBTTagCompound func_189515_b(NBTTagCompound tag){
        tag.func_74768_a("holdDelay", holdDelay);
        return super.func_189515_b(tag);
    }

    @Override
    public void func_145839_a(NBTTagCompound tag){
        holdDelay = tag.func_74762_e("holdDelay");
        super.func_145839_a(tag);
    }

    @Override
    protected void onDestinationChanged(MCPos destination){
        super.onDestinationChanged(destination);
        RailNetworkManager.getInstance(field_145850_b.field_72995_K).markDirty(getMCPos());
        updateLinkState();
    }

    private void updateLinkState(){
        NetworkRail<MCPos> linkedRail = getLinkedPosition() == null ? null : RailNetworkManager.getInstance(field_145850_b.field_72995_K).getRail(getLinkedPosition());
        field_145850_b.func_180501_a(func_174877_v(), field_145850_b.func_180495_p(func_174877_v()).func_177226_a(BlockRailLink.CONNECTED, linkedRail != null), 2);
    }
}
