package com.minemaarten.signals.tileentity;

import java.util.Objects;

import net.minecraft.entity.player.EntityPlayer;
import net.minecraft.nbt.NBTTagCompound;
import net.minecraft.util.math.BlockPos;

import com.minemaarten.signals.rail.network.mc.MCPos;

public abstract class TileEntityRailLinkBase extends TileEntityBase{
    private MCPos linkedPos;

    public MCPos getLinkedPosition(){
        return linkedPos;
    }

    public boolean setLinkedPos(MCPos railPos, EntityPlayer player){
        if(!Objects.equals(railPos, linkedPos)) {
            if(isDestinationValid(railPos, player)) {
                linkedPos = railPos;
                onDestinationChanged(railPos);
                return true;
            } else {
                return false;
            }

        } else {
            return true;
        }
    }

    protected boolean isDestinationValid(MCPos destination, EntityPlayer player){
        return true;
    }

    protected void onDestinationChanged(MCPos destination){

    }

    @Override
    public NBTTagCompound func_189515_b(NBTTagCompound tag){
        if(linkedPos != null) {
            tag.func_74768_a("linkedX", linkedPos.getX());
            tag.func_74768_a("linkedY", linkedPos.getY());
            tag.func_74768_a("linkedZ", linkedPos.getZ());
            tag.func_74768_a("linkedDim", linkedPos.getDimID());
        }

        return super.func_189515_b(tag);
    }

    @Override
    public void func_145839_a(NBTTagCompound tag){
        if(tag.func_74764_b("linkedX")) {
            BlockPos p = new BlockPos(tag.func_74762_e("linkedX"), tag.func_74762_e("linkedY"), tag.func_74762_e("linkedZ"));
            linkedPos = new MCPos(tag.func_74762_e("linkedDim"), p);
        } else {
            linkedPos = null;
        }

        super.func_145839_a(tag);
    }
}
